<template>
  <form class="mb-6" @submit="sendFile">
    <div class="field is-horizontal">
      <div class="field-label is-normal">
        <label class="label">Title</label>
      </div>
      <div class="field-body">
        <div class="field is-narrow">
          <div class="control">
            <input id="title" class="input" type="text" v-model="title" :size="inputSize"/>
          </div>
        </div>
      </div>
    </div>
    <div class="field is-horizontal">
      <div class="field-label is-normal">
        <label class="label">Input type</label>
      </div>
      <div class="field-body">
        <div class="field is-narrow">
          <div class="control">
            <label class="radio">
              <input type="radio" name="inputType" v-model="inputType" value="file" checked>
              I'll send the file
            </label>
            <label class="radio">
              <input type="radio" name="inputType" v-model="inputType" value="link">
              I'll attach the link
            </label>
          </div>
        </div>
      </div>
    </div>
    <div v-if="inputType === 'link'" class="field is-horizontal">
      <div class="field-label is-normal">
        <label class="label">File link</label>
      </div>
      <div class="field-body">
        <div class="field is-narrow">
          <div class="control">
            <input class="input" type="text" v-model="fileLink" :size="inputSize"/>
          </div>
        </div>
      </div>
    </div>
    <div v-if="inputType === 'file'" class="field is-horizontal">
      <div class="field-label is-normal">
        <label class="label">Raw file</label>
      </div>
      <div class="field-body">
        <div class="field">
          <div class="control">
            <div class="file has-name">
              <label class="file-label m-0">
                <input class="file-input"
                       type="file"
                       accept="video/mp4,video/x-m4v,video/*"
                       ref="rawFile"
                       @change="setFileTitle"/>
                <span class="file-cta">
                <span class="file-icon">
                  <i class="fas fa-upload"></i>
                </span>
                <span class="file-label">
                  Choose a file…
                </span>
                </span>
                <span class="file-name">
                  {{ fileTitle }}
                </span>
              </label>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="field is-horizontal">
      <div class="field-label is-normal">
        <label class="label"></label>
      </div>
      <div class="field-body has-text-left">
        <div class="field">
          <div class="control">
            <button class="button is-link" type="submit">Upload</button>
          </div>
        </div>
      </div>
    </div>
  </form>
  <div v-if="errorMessage" class="notification is-danger">
    <button class="delete" @click="errorMessage = ''"></button>
    File sending error: {{errorMessage}}
  </div>

  <table class="table is-bordered is-striped is-narrow is-hoverable is-fullwidth" v-if="units.length > 0">
    <thead>
    <tr>
      <th>Title</th>
      <th>Video</th>
      <th>Created</th>
      <th></th>
    </tr>
    </thead>
    <tbody>
    <tr v-for="unit in units" :key="unit.uid">
      <th>{{unit.title}}</th>
      <td>
        <video v-if="unit.mp4_file || unit.webm_file" controls>
          <source v-if="unit.webm_file" :src="unit.webm_file"
                  type="video/webm">
          <source v-if="unit.mp4_file" :src="unit.mp4_file"
                  type="video/mp4">
        </video>
        <img v-else :src="unit.preview"  alt="video preview"/>
      </td>
      <td>{{formatDate(unit.created)}}</td>
      <td><button class="button is-danger" @click="deleteFile(unit.uid)">DELETE</button></td>
    </tr>
    </tbody>
  </table>
</template>

<script lang="ts">
import { defineComponent } from 'vue'
import {SERVER_URL, API_VER} from "../consts";
import axios from "axios";

export default defineComponent({
  name: 'Units',
  props: {
    token: String,
    inputSize: Number
  },
  data() {
    return {
      client: null,
      inputType: 'file',
      units: [],
      title: '',
      rawFile: null,
      fileLink: null,
      errorMessage: '',
      fileTitle: 'no file',
      url: SERVER_URL + '/api/v' + API_VER + '/unit-list/',
    }
  },
  mounted() {
    this.client = axios.create({headers: {'Authorization': `Token ${this.token}`}})
    this.refreshData()
  },
  methods: {
    setFileTitle(el) {
      this.fileTitle = el.target.files[0].name
    },
    refreshData(){
      this.client.get(this.url)
          .then(res => {
            this.units = res.data
          })
          .catch(err => console.log(err))
    },
    sendFile(e){
      e.preventDefault()
      const formData = new FormData()
      formData.append('title', this.title)
      if (this.inputType === 'file') {
        const file = this.$refs.rawFile.files[0];
        formData.append('raw_file', file)
      } else {
        formData.append('file_link', this.fileLink)
      }
      this.client.post(
          this.url,
          formData
      ).then(_ => this.refreshData()).catch(err => this.errorMessage = err.response ? err.response.data : err)
    },
    deleteFile(unitUID){
      this.client.delete(this.url + unitUID).then(_ => this.refreshData()).catch(console.log)
    },
    formatDate(dateStr: string) {
      return (new Date(dateStr)).toLocaleString()
    }
  },
})
</script>

<style scoped>
a {
  color: #42b983;
}

label {
  margin: 0 0.5em;
  font-weight: bold;
}

code {
  background-color: #eee;
  padding: 2px 4px;
  border-radius: 4px;
  color: #304455;
}
</style>
